import { windowEndpoint } from "comlink";
const mockEndpoint = {
    postMessage() {
        // noop
    },
    addEventListener: () => {
        // noop
    },
    removeEventListener: () => {
        // noop
    },
};
const webViewEndpoint = {
    postMessage: (data) => {
        console.debug("[webview:req]", data);
        window.ReactNativeWebView.postMessage(JSON.stringify(data));
    },
    addEventListener: (_, listener, ...args) => {
        document.addEventListener("FarcasterFrameCallback", listener, ...args);
    },
    removeEventListener: (_, listener) => {
        document.removeEventListener("FarcasterFrameCallback", listener);
    },
};
export const endpoint = (() => {
    var _a;
    // No actions are actually gonna take place during SSR, thus it's safe to return mocked endpoint
    if (typeof window === 'undefined')
        return mockEndpoint;
    return (window === null || window === void 0 ? void 0 : window.ReactNativeWebView)
        ? webViewEndpoint
        : windowEndpoint((_a = window === null || window === void 0 ? void 0 : window.parent) !== null && _a !== void 0 ? _a : window);
})();
